/* Écriture des textes en EEPROM pour diminuer la place occupée dans la zone
   des variables dynamiques.
   Plus une chaire est longue, plus elle est "rentable". */

#include <EEPROM.h>

int PTR;
char Caractere;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.

void setup() { Serial.begin(115200); 
  TEXTE_a_inscrire_en_EEPROM.reserve(30); } // 30 caractères sont très suffisants.

void loop() {  
  PTR = 617; // PTR pointe la première adresse disponible pour les textes, la fin étant en 1023.    

  // Ci-dessous : Possibilité de "purger une zone avec des #FF.
  //for (int i=617; i < 644; i++) EEPROM.write(i, 255);
  
  TEXTE_a_inscrire_en_EEPROM = "Hanche "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Genou "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Pied "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Manuel : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "%Sonde sur berceau ?"; Ecrire_Texte_en_EEPROM(); 
  TEXTE_a_inscrire_en_EEPROM = " cm"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " > ("; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "/30 "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "OFF : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = ">>> "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Lacet"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "APPRENTISSAGE"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Repete"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Distance : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Luxmetre : "; Ecrire_Texte_en_EEPROM();    
  TEXTE_a_inscrire_en_EEPROM = " OK!"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "ERR "; Ecrire_Texte_en_EEPROM(); 
  TEXTE_a_inscrire_en_EEPROM = "Angle "; Ecrire_Texte_en_EEPROM(); 
  TEXTE_a_inscrire_en_EEPROM = "Bouclier au sol : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Phares actifs : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "LASER actif : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Conversion CAN Neutralisee : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Valeur numerique = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Bloquer les niveaux : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Eclairage = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Tangage+"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "FIN !"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Sommeil : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Tension Moteurs : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Dernier PGM actif : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "MvtsRoulis-"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Rapides"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Lents"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Posture = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Humidite : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Temperature : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Torsion = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Orientation : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "OUINON"; Ecrire_Texte_en_EEPROM();
  
 // Ci-dessous : Possibilité de "purger une zone avec des #FF.
 // for (int i=665; i < 681; i++) EEPROM.write(i, 254); 
  
  Lister_EEPROM();
  INFINI: goto INFINI; }
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE.
  while ((PTR < 1024) && (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++; }
  Serial.println(); }
  
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC(); }
  
void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
  
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}
   
void Lister_OCTET() {
  byte octet = EEPROM.read(PTR); 
  if ((octet > 31) && (octet < 126)) {Serial.print(' '); Serial.print(char(octet));}
  else Serial.print("..");
  Serial.print(' '); PTR++; }
